## mythtv-dmo 35.0+really35+fixes20251031.git48241b2

=== libs/CMakeLists.txt ===
add_subdirectory(libmythbase)
add_subdirectory(libmythservicecontracts)
if(TARGET mythtv_mheg)
  add_subdirectory(libmythfreemheg)
endif()
if(NOT CONFIG_LIBMPEG2EXTERNAL)
  add_subdirectory(libmythmpeg2)
endif()
add_subdirectory(libmythui)
add_subdirectory(libmythupnp)
add_subdirectory(libmyth)
add_subdirectory(libmythtv)
add_subdirectory(libmythmetadata)
add_subdirectory(libmythprotoserver)
