=== external/libexiv2/include/exiv2/CMakeLists.txt ===
install(FILES
            basicio.hpp
            bigtiffimage.hpp
            bmpimage.hpp
            config.h
            convert.hpp
            cr2image.hpp
            crwimage.hpp
            datasets.hpp
            easyaccess.hpp
            error.hpp
            exif.hpp
            exiv2.hpp
            futils.hpp
            gifimage.hpp
            http.hpp
            image.hpp
            image_types.hpp
            ini.hpp
            iptc.hpp
            jp2image.hpp
            jpgimage.hpp
            metadatum.hpp
            mrwimage.hpp
            orfimage.hpp
            pgfimage.hpp
            pngimage.hpp
            preview.hpp
            properties.hpp
            psdimage.hpp
            rafimage.hpp
            rw2image.hpp
            slice.hpp
            tags.hpp
            tgaimage.hpp
            tiffimage.hpp
            types.hpp
            value.hpp
            version.hpp
            webpimage.hpp
            xmp_exiv2.hpp
            xmpsidecar.hpp
        DESTINATION
            ${CMAKE_INSTALL_INCLUDEDIR}/mythtv/exiv2)
