=== debian/changelog ===
mythtv-dmo (1:35.0+really35+fixes20251031.git48241b2-dmo1) unstable; urgency=medium

  * New upstream bugfix release from git repository.

 -- Christian Marillat <marillat@deb-multimedia.org>  Fri, 31 Oct 2025 16:03:46 +0100
